!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  Structured Markov Chains Solver      [  SMCSolver  ]       !
!  Dario Bini, Beatrice Meini, Sergio Steffe'                 !
!  bini@dm.unipi.it, meini@dm.unipi.it, steffe@dm.unipi.it    !
!  Dipartimento di Matematica "Leonida Tonelli"               !
!  Largo Pontecorvo 5                                         !
!  56127 Pisa                                                 !
!  Italy                                                      !
!  Version 2.1 - June  2009                                   !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!
!
module pi_int
interface
subroutine qbdpi(Am1, A0, A1, Bm1, B0, B1, R, maxnc, epspi, pi0,pi,pinc)
integer,parameter:: dp=kind(0.d0)
  integer :: maxnc, pinc
  real(dp),dimension(:,:) :: Am1, A0, A1, Bm1, B0,  R
  real(dp),dimension(:,:), optional :: B1
  real(dp),dimension(:,:)::pi
   real(dp),dimension(:):: pi0
  real(dp):: epspi
end subroutine qbdpi
end interface

interface
 subroutine mg1pi(A, B0, B, Bm1, G, maxnc, epspi, pi0, pi,pinc)
   integer,parameter:: dp=kind(0.d0)
   integer :: maxnc,pinc
   real(dp),dimension(:,:,:) :: A, B
   real(dp),dimension(:,:), optional :: Bm1
   real(dp),dimension(:,:)::pi,G,B0
   real(dp),dimension(:):: pi0
   real(dp):: epspi
 end subroutine mg1pi
end interface

interface
subroutine gm1pi(A, B, B0, Bm1, R, maxnc, epspi, pi0, pi,pinc)
  integer,parameter:: dp=kind(0.d0)
   integer :: maxnc,pinc
   real(dp),dimension(:,:,:) :: A, B
   real(dp),dimension(:,:), optional :: Bm1
   real(dp),dimension(:,:)::pi,R,B0
   real(dp),dimension(:):: pi0
   real(dp):: epspi
 end subroutine gm1pi
end interface

end module pi_int
